## The Python Standard Library​
{:.no_toc}

<nav markdown="1" class="toc-class">
* TOC
{:toc}
</nav>

## The goal

More than the standard instruction set...​

Questions to [David Rotermund](mailto:davrot@uni-bremen.de)

## [Text Processing Services](https://docs.python.org/3/library/text.html​)

> The modules described in this chapter provide a wide range of string manipulation operations and other text processing services.​

|||
|---|---|
|​string | Common string operations​|
|re | Regular expression operations​|
|difflib | Helpers for computing deltas​|
|textwrap | Text wrapping and filling​|
|unicodedata | Unicode Database​|
|stringprep | Internet String Preparation​|
|readline | GNU readline interface​|
|rlcompleter | Completion function for GNU readline|


## [Binary Data Services​](https://docs.python.org/3/library/binary.html​)

> The modules described in this chapter provide some basic services operations for manipulation of binary data. Other operations on binary data, specifically in relation to file formats and network protocols, are described in the relevant sections.​

|||
|---|---|
|struct | Interpret bytes as packed binary data​|
|codecs | Codec registry and base classes|

## [Data Types](https://docs.python.org/3/library/datatypes.html​)

> The modules described in this chapter provide a variety of specialized data types such as dates and times, fixed-type arrays, heap queues, double-ended queues, and enumerations.​

​|||
|---|---|
|**datetime** | **Basic date and time types​**|
|zoneinfo | IANA time zone support​|
|calendar | General calendar-related functions​|
|collections | Container datatypes​|
|**collections.abc** | **Abstract Base Classes for Containers​**|
|heapq | Heap queue algorithm​|
|bisect | Array bisection algorithm​|
|array | Efficient arrays of numeric values​|
|weakref | Weak references​|
|**types** | Dynamic type creation and names for built-in types​|
|copy | Shallow and deep copy operations​|
|pprint | Data pretty printer​|
|reprlib | Alternate repr() implementation​|
|enum | Support for enumerations​|
|graphlib | Functionality to operate with graph-like structures|

470

